program PropagateQueens;
uses Dos;
var
    n : integer; { ###### ##### }
    queen : array[1..200] of integer; { ###### ######### ###### }
    space : array[1..160,1..160] of integer; { ############ ######## }
    vstep : array[1..200] of integer; { ####### ###### ###### }
    cases : array[1..200] of integer; { ########## ######### }

{ ######### ###### ####### }
procedure WriteSolution;
var
    i : integer;
begin
    for i := 1 to n do Write(queen[i],' ');
    WriteLn
end;

{ ######### ########## ############ ######## }
procedure Prune(qm,queen,m : integer);
var i, nq : integer;
        procedure ExcludeField(queen : integer);
        begin
        if (queen >= 1) and (queen <= n) then
            if space[nq,queen] = 0 then begin
                Dec(cases[nq]); space[nq,queen] := m;
            end;
        end;
begin
    for i := m+1 to n do begin
        nq := vstep[i];
        ExcludeField(queen); { ## ### ## ########### }
        ExcludeField(queen+nq-qm); { ## ### ## ######### }
        ExcludeField(queen-nq+qm);
    end;
end;

{ ######### ############## ############ ######## }
procedure Restore(qm,queen,m : integer);
var i, nq : integer;
    procedure IncludeField(queen : integer);
    begin
        if (queen >= 1) and (queen <= n) then
        if space[nq,queen] = m then begin
            Inc(cases[nq]); space[nq,queen] := 0;
        end;
    end;
begin
    for i := m+1 to n do begin
        nq := vstep[i];
        IncludeField(queen); { ## ### ## ########### }
        IncludeField(queen+nq-qm); { ## ### ## ######### }
        IncludeField(queen-nq+qm);
    end;
end;

var minq, l : integer;
procedure Propagate(m : integer);
var i, q, qm : integer;
begin
    if m > n then { WriteSolution }
    else begin
    { ########## ##### # ########## ########### ######### }
        minq := n+1;
        for i := m to n do
            if cases[vstep[i]] <= minq then begin
                l := i; qm := vstep[l]; minq := cases[qm];
            end;
        vstep[l] := vstep[m]; vstep[m] := qm;
        for q := 1 to n do begin
            if space[qm,q] = 0 then begin
                queen[qm] := q;
                Prune(qm,q,m);
                Propagate(m+1);
                Restore(qm,q,m);
            end;
        end;
    end;
end;

var i, j : integer;
h1, m1, s1, hund1,
h2, m2, s2, hund2 : Word; { For GetTime}
time : longint;
begin
    Write('###### #####? '); Read(n);
    GetTime(h1,m1,s1,hund1);
    for i := 1 to n do begin
        for j := 1 to n do space[i,j] := 0;
        vstep[i] := i;
        cases[i] := n;
    end;
    Propagate(1);
    GetTime(h2,m2,s2,hund2);
    time := (hund2-hund1)+(s2-s1)*100+(m2-m1)*6000+(h2-h1)*360000;
    WriteLn(time);
end.
